﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Operators;
using HeuristicLab.Optimization;
using HeuristicLab.Core;
using HeuristicLab.Parameters;
using HeuristicLab.Common;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Data;

namespace HeuristicLab.Problems.MetaOptimization {
  // todo: item name/descr...
  [StorableClass]
  public class ParameterConfigurationOnePositionsManipulator : ParameterConfigurationManipulator {

    public ParameterConfigurationOnePositionsManipulator() { }
    [StorableConstructor]
    protected ParameterConfigurationOnePositionsManipulator(bool deserializing) : base(deserializing) { }
    protected ParameterConfigurationOnePositionsManipulator(ParameterConfigurationOnePositionsManipulator original, Cloner cloner)
      : base(original, cloner) {
    }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new ParameterConfigurationOnePositionsManipulator(this, cloner);
    }

    public sealed override IOperation Apply() {
      Apply(RandomParameter.ActualValue, ParameterConfigurationTreeParameter.ActualValue, IntValueManipulatorParameter.ActualValue, DoubleValueManipulatorParameter.ActualValue);
      return base.Apply();
    }

    public static void Apply(IRandom random, ParameterConfigurationTree configuration, IIntValueManipulator intValueManipulator, IDoubleValueManipulator doubleValueManipulator) {
      IOptimizable optimizable = configuration.GetRandomOptimizable(random);
      Mutate(random, optimizable, intValueManipulator, doubleValueManipulator);
    }
  }
}